"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.listThrowTraversalError = exports.listGet = exports.listInit = void 0;
function listInit(list, values) {
    values.forEach(function (v) {
        list.append(v);
    });
}
exports.listInit = listInit;
function listGet(list, index) {
    var length = list.length();
    if (index < 0 || (length > 0 && index >= length)) {
        throw new RangeError("index " + index + " is not in bounds");
    }
    var node = list._getNode(index);
    return (node === null || node === void 0 ? void 0 : node.value) || null;
}
exports.listGet = listGet;
function listThrowTraversalError() {
    throw new Error("list traversal failed because a node along path to destination index was null");
}
exports.listThrowTraversalError = listThrowTraversalError;
